library(ggplot2)

trait_plot3 <- function(seq_result, data_name){
  rand_intro <- rbind( unlist(seq_result[[11]]), unlist(seq_result[[1]]$rand_intro), unlist(seq_result[[2]]$rand_intro),
                      unlist(seq_result[[3]]$rand_intro), unlist(seq_result[[4]]$rand_intro),
                      unlist(seq_result[[5]]$rand_intro), unlist(seq_result[[6]]$rand_intro),
                      unlist(seq_result[[7]]$rand_intro), unlist(seq_result[[8]]$rand_intro),
                      unlist(seq_result[[9]]$rand_intro))
  rand_intro <- cbind(rand_intro, 2 * (rand_intro[,7] * rand_intro[,8])/ (rand_intro[,7] + rand_intro[,8]) )
  thresh_intro <- rbind(unlist(seq_result[[11]]), unlist(seq_result[[1]]$thresh_intro), unlist(seq_result[[2]]$thresh_intro),
                        unlist(seq_result[[3]]$thresh_intro), unlist(seq_result[[4]]$thresh_intro),
                        unlist(seq_result[[5]]$thresh_intro), unlist(seq_result[[6]]$thresh_intro), unlist(seq_result[[7]]$thresh_intro),
                        unlist(seq_result[[8]]$thresh_intro), unlist(seq_result[[9]]$thresh_intro))
  thresh_intro <- cbind(thresh_intro, 2 * (thresh_intro[,7] * thresh_intro[,8])/ (thresh_intro[,7] + thresh_intro[,8]) )
  double_exp_intro <- rbind(unlist(seq_result[[11]]), unlist(seq_result[[1]]$double_exp_intro), unlist(seq_result[[2]]$double_exp_intro),
                            unlist(seq_result[[3]]$double_exp_intro), unlist(seq_result[[4]]$double_exp_intro),
                            unlist(seq_result[[5]]$double_exp_intro), unlist(seq_result[[6]]$double_exp_intro), unlist(seq_result[[7]]$double_exp_intro),
                            unlist(seq_result[[8]]$double_exp_intro), unlist(seq_result[[9]]$double_exp_intro))
  double_exp_intro <- cbind(double_exp_intro, 2 * (double_exp_intro[,7] * double_exp_intro[,8])/ (double_exp_intro[,7] + double_exp_intro[,8]) )
  gene_thresh_intro <- rbind(unlist(seq_result[[11]]), unlist(seq_result[[1]]$gene_thresh_intro), unlist(seq_result[[2]]$gene_thresh_intro),
                             unlist(seq_result[[3]]$gene_thresh_intro), unlist(seq_result[[4]]$gene_thresh_intro),
                             unlist(seq_result[[5]]$gene_thresh_intro), unlist(seq_result[[6]]$gene_thresh_intro), unlist(seq_result[[7]]$gene_thresh_intro),
                             unlist(seq_result[[8]]$gene_thresh_intro), unlist(seq_result[[9]]$gene_thresh_intro))
  gene_thresh_intro <- cbind(gene_thresh_intro, 2 * (gene_thresh_intro[,7] * gene_thresh_intro[,8])/ (gene_thresh_intro[,7] + gene_thresh_intro[,8]) )
  gene_double_exp_intro <- rbind(unlist(seq_result[[11]]), unlist(seq_result[[1]]$gene_double_exp_intro), unlist(seq_result[[2]]$gene_double_exp_intro),
                                 unlist(seq_result[[3]]$gene_double_exp_intro), unlist(seq_result[[4]]$gene_double_exp_intro),
                                 unlist(seq_result[[5]]$gene_double_exp_intro), unlist(seq_result[[6]]$gene_double_exp_intro), unlist(seq_result[[7]]$gene_double_exp_intro),
                                 unlist(seq_result[[8]]$gene_double_exp_intro), unlist(seq_result[[9]]$gene_double_exp_intro))
  gene_double_exp_intro <- cbind(gene_double_exp_intro, 2 * (gene_double_exp_intro[,7] * gene_double_exp_intro[,8])/ (gene_double_exp_intro[,7] + gene_double_exp_intro[,8]) )
  print(cbind(rand_intro[,1], 1:10))
  
  
  feature_vec <- c("zero_proportion",  "nmi",  "ari",
                   "mg_preci",  "mg_recall", "Jaccard Index",
                   "DE_preci",  "DE_recall", "DE_F1")
  pdf(paste0("Plots/ari_", data_name, ".pdf", sep = ""))
  plot(x = rand_intro[,1], y = rand_intro[,3], type = "l", col = alpha("#8c510a", 0.5), lwd = 16, ylim = c(0,1), main = feature_vec[3])
  lines(x = rand_intro[,1], y = thresh_intro[,3], col = alpha("#fdae61", 0.5), lwd = 16)
  lines(x = rand_intro[,1], y = double_exp_intro[,3], col = alpha("#756bb1", 0.5), lwd = 16)
  lines(x = rand_intro[,1], y = gene_thresh_intro[,3], col = alpha("#d7191c", 0.5), lwd = 16)
  lines(x = rand_intro[,1], y = gene_double_exp_intro[,3], col = alpha("#2c7bb6", 0.5), lwd = 16)
  dev.off()
  
  # pdf(paste0("Plots/Jaccard_", data_name, ".pdf", sep = ""))
  # plot(x = rand_intro[,1], y = rand_intro[,6], type = "l", col = alpha("#8c510a", 0.5), lwd = 16, ylim = c(0,1), main = feature_vec[6])
  # lines(x = rand_intro[,1], y = thresh_intro[,6], col = alpha("#fdae61", 0.5), lwd = 16)
  # lines(x = rand_intro[,1], y = double_exp_intro[,6], col = alpha("#756bb1", 0.5), lwd = 16)
  # lines(x = rand_intro[,1], y = gene_thresh_intro[,6], col = alpha("#d7191c", 0.5), lwd = 16)
  # lines(x = rand_intro[,1], y = gene_double_exp_intro[,6], col = alpha("#2c7bb6", 0.5), lwd = 16)
  # 
  # dev.off()
  
  pdf(paste0("Plots/DE_recall_", data_name, ".pdf", sep = ""))
  plot(x = rand_intro[,1], y = rand_intro[,8], type = "l", col = alpha("#8c510a", 0.5), lwd = 16, ylim = c(0,1), main = feature_vec[8])
  lines(x = rand_intro[,1], y = thresh_intro[,8], col = alpha("#fdae61", 0.5), lwd = 16)
  lines(x = rand_intro[,1], y = double_exp_intro[,8], col = alpha("#756bb1", 0.5), lwd = 16)
  lines(x = rand_intro[,1], y = gene_thresh_intro[,8], col = alpha("#d7191c", 0.5), lwd = 16)
  lines(x = rand_intro[,1], y = gene_double_exp_intro[,8], col = alpha("#2c7bb6", 0.5), lwd = 16)
  dev.off()

  pdf(paste0("Plots/DE_precision_", data_name, ".pdf", sep = ""))
  plot(x = rand_intro[,1], y = rand_intro[,7], type = "l", col = alpha("#8c510a", 0.5), lwd = 16, ylim = c(0,1), main = feature_vec[8])
  lines(x = rand_intro[,1], y = thresh_intro[,7], col = alpha("#fdae61", 0.5), lwd = 16)
  lines(x = rand_intro[,1], y = double_exp_intro[,7], col = alpha("#756bb1", 0.5), lwd = 16)
  lines(x = rand_intro[,1], y = gene_thresh_intro[,7], col = alpha("#d7191c", 0.5), lwd = 16)
  lines(x = rand_intro[,1], y = gene_double_exp_intro[,7], col = alpha("#2c7bb6", 0.5), lwd = 16)
  dev.off()
  
  pdf(paste0("Plots/DE_F1_", data_name, ".pdf", sep = ""))
  plot(x = rand_intro[,1], y = rand_intro[,9], type = "l", col = alpha("#8c510a", 0.5), lwd = 16, ylim = c(0,0.6), main = feature_vec[9])
  lines(x = rand_intro[,1], y = thresh_intro[,9], col = alpha("#fdae61", 0.5), lwd = 16)
  lines(x = rand_intro[,1], y = double_exp_intro[,9], col = alpha("#756bb1", 0.5), lwd = 16)
  lines(x = rand_intro[,1], y = gene_thresh_intro[,9], col = alpha("#d7191c", 0.5), lwd = 16)
  lines(x = rand_intro[,1], y = gene_double_exp_intro[,9], col = alpha("#2c7bb6", 0.5), lwd = 16)
  dev.off()
}

result_seurat_Smartseq2_PBMC <- readRDS("Result_11202020/Smartseq2_result_seurat_PMBC2_rev.RDS")
trait_plot3(result_seurat_Smartseq2_PBMC, "Smartseq2_PBMC_seurat")

result_monocle3_Smartseq2_PBMC <- readRDS("Result_11202020/SMARTseq2_result_PBMC2_rev.RDS")
trait_plot3(result_monocle3_Smartseq2_PBMC, "Smartseq2_PBMC_monocle3")

result_seurat_dropseq_PBMC <- readRDS("Result_11202020/Dropseq_result_seurat_PMBC2_rev.RDS")
trait_plot3(result_seurat_dropseq_PBMC, "dropseq_PBMC_seurat")

result_monocle3_dropseq_PBMC <- readRDS("Result_11202020/dropseq_result_PBMC2_rev.RDS")
trait_plot3(result_monocle3_dropseq_PBMC, "dropseq_PBMC_monocle3")

result_seurat_10x_PBMC <- readRDS("Result_11202020/10x_result_seurat_PMBC2_rev.RDS")
trait_plot3(result_seurat_10x_PBMC, "10x_PBMC_seurat")

result_monocle3_10x_PBMC <- readRDS("Result_11202020/10x_result_PBMC2_rev.RDS")
trait_plot3(result_monocle3_10x_PBMC, "10x_PBMC_monocle3")



